#!/usr/bin/perl
#
# Generate the video character generator portion in Altera MIF format
#

use bytes;
binmode STDOUT;

%charsets = ( 'abcsefi' =>
	      "                                ".
	      " !\"#%&\'()*+,-./0123456789:;<=>?".
	      "ABCDEFGHIJKLMNOPQRSTUVWXYZ_".
	      "abcdefghijklmnopqrstuvwxyz\x7f",
	      
	      'abcdkno' =>
	      "                                ".
	      " !\"#%&\'()*+,-./0123456789:;<=>?".
	      "ABCDEFGHIJKLMNOPQRSTUVWXYZ_".
	      "abcdefghijklmnopqrstuvwxyz\x7f",
	      
	      'abcintl' =>
	      "                                ".
	      " !\"#\$%&\'()*+,-./0123456789:;<=>?".
	      "\@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_".
	      "`abcdefghijklmnopqrstuvwxyz{|}~\x7f"
	      );

($set) = @ARGV;
$set = 'abcsefi' if ( !defined($charsets{$set}) );
$chars = $charsets{$set};

while ( defined($line = <STDIN>) ) {
    chomp $line;
    if ( $line =~ /^FONTBOUNDINGBOX\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/ ) {
	$xsize = $1 + 0;
	$ysize = $2 + 0;
	$xoff  = $3 + 0;
	$yoff  = $4 + 0;
	@bitmasks = ("\0" x $ysize) x 256;
    } elsif ( $line =~ /^ENCODING\s+(\S+)/ ) {
	$thischar = $1 + 0;
    } elsif ( $line =~ /^BBX\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/ ) {
	$cxsize = $1 + 0;
	$cysize = $2 + 0;
	$xstart = $3 - $xoff;
	$ystart = $ysize - $4 - $cysize + $yoff;
    } elsif ( $line =~/^BITMAP\b/ ) {
	for ( $i = 0 ; $i < $cysize ; $i++ ) {
	    $line = <STDIN>;
	    substr($bitmasks[$thischar], $i+$ystart, 1) =
		chr((hex $line) >> $xstart);
	}
    }
}

# Print out the initialization vectors for the screen fonts
for ( $i = 0 ; $i < 128 ; $i++ ) {
    print $bitmasks[ord(substr($chars,$i,1))];
}
